/* archive-reader.c generated by valac 0.56.18, the Vala compiler
 * generated from archive-reader.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/

#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <archive_entry.h>
#include "common.h"
#include <stdio.h>
#include <glib/gstdio.h>

#define BOXES_ARCHIVE_READER_BLOCK_SIZE 10240
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define BOXES_TYPE_ARCHIVE_READER (boxes_archive_reader_get_type ())
#define BOXES_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader))
#define BOXES_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))
#define BOXES_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_ARCHIVE_READER))
#define BOXES_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReaderClass))

typedef struct _BoxesArchiveReader BoxesArchiveReader;
typedef struct _BoxesArchiveReaderClass BoxesArchiveReaderClass;
typedef struct _BoxesArchiveReaderPrivate BoxesArchiveReaderPrivate;
enum  {
	BOXES_ARCHIVE_READER_0_PROPERTY,
	BOXES_ARCHIVE_READER_NUM_PROPERTIES
};
static GParamSpec* boxes_archive_reader_properties[BOXES_ARCHIVE_READER_NUM_PROPERTIES];
#define _archive_read_free0(var) ((var == NULL) ? NULL : (var = (archive_read_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block15Data Block15Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _BoxesArchiveReader {
	GObject parent_instance;
	BoxesArchiveReaderPrivate * priv;
	struct archive* archive;
};

struct _BoxesArchiveReaderClass {
	GObjectClass parent_class;
};

struct _BoxesArchiveReaderPrivate {
	gchar* filename;
	int* format;
	GList* filters;
};

struct _Block14Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	FILE* fd;
};

struct _Block15Data {
	int _ref_count_;
	BoxesArchiveReader* self;
	int filter;
};

static gint BoxesArchiveReader_private_offset;
static gpointer boxes_archive_reader_parent_class = NULL;

VALA_EXTERN GType boxes_archive_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoxesArchiveReader, g_object_unref)
VALA_EXTERN BoxesArchiveReader* boxes_archive_reader_new (const gchar* filename,
                                              int* format,
                                              GList* filters,
                                              GError** error);
VALA_EXTERN BoxesArchiveReader* boxes_archive_reader_construct (GType object_type,
                                                    const gchar* filename,
                                                    int* format,
                                                    GList* filters,
                                                    GError** error);
static int* _archive_format_dup (int* self);
static void boxes_archive_reader_open_archive (BoxesArchiveReader* self,
                                        GError** error);
VALA_EXTERN GList* boxes_archive_reader_get_file_list (BoxesArchiveReader* self,
                                           GError** error);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN void boxes_archive_reader_extract_file (BoxesArchiveReader* self,
                                        const gchar* src,
                                        const gchar* dest,
                                        gboolean override_if_necessary,
                                        GError** error);
static void boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self,
                                                   gchar** src_list,
                                                   gint src_list_length1,
                                                   gchar** dest_list,
                                                   gint dest_list_length1,
                                                   gboolean override_if_necessary,
                                                   gboolean follow_hardlinks,
                                                   GError** error);
VALA_EXTERN void boxes_archive_reader_reset (BoxesArchiveReader* self,
                                 GError** error);
static int _archive_read_close_boxes_libarchive_function (gpointer self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static gchar* boxes_archive_reader_get_dest_file (BoxesArchiveReader* self,
                                           gchar** src_list,
                                           gint src_list_length1,
                                           gchar** dest_list,
                                           gint dest_list_length1,
                                           const gchar* src);
static int _archive_read_data_skip_boxes_libarchive_function (gpointer self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static int ___lambda23_ (Block14Data* _data14_);
static int ____lambda23__boxes_libarchive_function (gpointer self);
static int _archive_read_support_format_all_boxes_libarchive_function (gpointer self);
static int ___lambda20_ (BoxesArchiveReader* self);
static int ____lambda20__boxes_libarchive_function (gpointer self);
static int _archive_read_support_filter_all_boxes_libarchive_function (gpointer self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static int _____lambda21_ (Block15Data* _data15_);
static int ______lambda21__boxes_libarchive_function (gpointer self);
static int __lambda22_ (BoxesArchiveReader* self);
static int ___lambda22__boxes_libarchive_function (gpointer self);
static void boxes_archive_reader_finalize (GObject * obj);
static GType boxes_archive_reader_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
boxes_archive_reader_get_instance_private (BoxesArchiveReader* self)
{
	return G_STRUCT_MEMBER_P (self, BoxesArchiveReader_private_offset);
}

static int*
_archive_format_dup (int* self)
{
	int* dup;
#line 18 "../src/archive-reader.vala"
	dup = g_new0 (int, 1);
#line 18 "../src/archive-reader.vala"
	memcpy (dup, self, sizeof (int));
#line 18 "../src/archive-reader.vala"
	return dup;
#line 182 "archive-reader.c"
}

static gpointer
__archive_format_dup0 (gpointer self)
{
#line 18 "../src/archive-reader.vala"
	return self ? _archive_format_dup (self) : NULL;
#line 190 "archive-reader.c"
}

BoxesArchiveReader*
boxes_archive_reader_construct (GType object_type,
                                const gchar* filename,
                                int* format,
                                GList* filters,
                                GError** error)
{
	BoxesArchiveReader * self = NULL;
	gchar* _tmp0_;
	int* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 13 "../src/archive-reader.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 13 "../src/archive-reader.vala"
	self = (BoxesArchiveReader*) g_object_new (object_type, NULL);
#line 17 "../src/archive-reader.vala"
	_tmp0_ = g_strdup (filename);
#line 17 "../src/archive-reader.vala"
	_g_free0 (self->priv->filename);
#line 17 "../src/archive-reader.vala"
	self->priv->filename = _tmp0_;
#line 18 "../src/archive-reader.vala"
	_tmp1_ = __archive_format_dup0 (format);
#line 18 "../src/archive-reader.vala"
	_g_free0 (self->priv->format);
#line 18 "../src/archive-reader.vala"
	self->priv->format = _tmp1_;
#line 19 "../src/archive-reader.vala"
	if (filters != NULL) {
#line 222 "archive-reader.c"
		GList* _tmp2_;
#line 20 "../src/archive-reader.vala"
		_tmp2_ = g_list_copy (filters);
#line 20 "../src/archive-reader.vala"
		(self->priv->filters == NULL) ? NULL : (self->priv->filters = (g_list_free (self->priv->filters), NULL));
#line 20 "../src/archive-reader.vala"
		self->priv->filters = _tmp2_;
#line 230 "archive-reader.c"
	}
#line 22 "../src/archive-reader.vala"
	boxes_archive_reader_open_archive (self, &_inner_error0_);
#line 22 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 22 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 22 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 22 "../src/archive-reader.vala"
			_g_object_unref0 (self);
#line 22 "../src/archive-reader.vala"
			return NULL;
#line 244 "archive-reader.c"
		} else {
#line 22 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 22 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 22 "../src/archive-reader.vala"
			return NULL;
#line 252 "archive-reader.c"
		}
	}
#line 13 "../src/archive-reader.vala"
	return self;
#line 257 "archive-reader.c"
}

BoxesArchiveReader*
boxes_archive_reader_new (const gchar* filename,
                          int* format,
                          GList* filters,
                          GError** error)
{
#line 13 "../src/archive-reader.vala"
	return boxes_archive_reader_construct (BOXES_TYPE_ARCHIVE_READER, filename, format, filters, error);
#line 268 "archive-reader.c"
}

static void
_g_free0_ (gpointer var)
{
#line 28 "../src/archive-reader.vala"
	var = (g_free (var), NULL);
#line 276 "archive-reader.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 28 "../src/archive-reader.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 284 "archive-reader.c"
}

GList*
boxes_archive_reader_get_file_list (BoxesArchiveReader* self,
                                    GError** error)
{
	GList* _result_ = NULL;
	struct archive_entry* iterator = NULL;
	GError* _inner_error0_ = NULL;
	GList* result;
#line 25 "../src/archive-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/archive-reader.vala"
	_result_ = NULL;
#line 28 "../src/archive-reader.vala"
	while (TRUE) {
#line 301 "archive-reader.c"
		gboolean _tmp0_ = FALSE;
		struct archive* _tmp1_;
		struct archive_entry* _tmp2_ = NULL;
		gboolean _tmp3_;
		struct archive_entry* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 28 "../src/archive-reader.vala"
		_tmp1_ = self->archive;
#line 28 "../src/archive-reader.vala"
		_tmp3_ = boxes_get_next_header (_tmp1_, &_tmp2_, (guint) 1, &_inner_error0_);
#line 28 "../src/archive-reader.vala"
		iterator = _tmp2_;
#line 28 "../src/archive-reader.vala"
		_tmp0_ = _tmp3_;
#line 28 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 28 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 28 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 28 "../src/archive-reader.vala"
				(_result_ == NULL) ? NULL : (_result_ = (_g_list_free__g_free0_ (_result_), NULL));
#line 28 "../src/archive-reader.vala"
				return NULL;
#line 327 "archive-reader.c"
			} else {
#line 28 "../src/archive-reader.vala"
				(_result_ == NULL) ? NULL : (_result_ = (_g_list_free__g_free0_ (_result_), NULL));
#line 28 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 28 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 28 "../src/archive-reader.vala"
				return NULL;
#line 337 "archive-reader.c"
			}
		}
#line 28 "../src/archive-reader.vala"
		if (!_tmp0_) {
#line 28 "../src/archive-reader.vala"
			break;
#line 344 "archive-reader.c"
		}
#line 29 "../src/archive-reader.vala"
		_tmp4_ = iterator;
#line 29 "../src/archive-reader.vala"
		_tmp5_ = archive_entry_pathname (_tmp4_);
#line 29 "../src/archive-reader.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 29 "../src/archive-reader.vala"
		_result_ = g_list_append (_result_, _tmp6_);
#line 354 "archive-reader.c"
	}
#line 31 "../src/archive-reader.vala"
	result = _result_;
#line 31 "../src/archive-reader.vala"
	return result;
#line 360 "archive-reader.c"
}

void
boxes_archive_reader_extract_file (BoxesArchiveReader* self,
                                   const gchar* src,
                                   const gchar* dest,
                                   gboolean override_if_necessary,
                                   GError** error)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
#line 35 "../src/archive-reader.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/archive-reader.vala"
	g_return_if_fail (src != NULL);
#line 35 "../src/archive-reader.vala"
	g_return_if_fail (dest != NULL);
#line 39 "../src/archive-reader.vala"
	_tmp0_ = g_strdup (src);
#line 39 "../src/archive-reader.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 39 "../src/archive-reader.vala"
	_tmp1_[0] = _tmp0_;
#line 39 "../src/archive-reader.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/archive-reader.vala"
	_tmp2__length1 = 1;
#line 39 "../src/archive-reader.vala"
	_tmp3_ = g_strdup (dest);
#line 39 "../src/archive-reader.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 39 "../src/archive-reader.vala"
	_tmp4_[0] = _tmp3_;
#line 39 "../src/archive-reader.vala"
	_tmp5_ = _tmp4_;
#line 39 "../src/archive-reader.vala"
	_tmp5__length1 = 1;
#line 39 "../src/archive-reader.vala"
	boxes_archive_reader_extract_files_recursive (self, _tmp2_, (gint) 1, _tmp5_, (gint) 1, override_if_necessary, TRUE, &_inner_error0_);
#line 39 "../src/archive-reader.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 39 "../src/archive-reader.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 39 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 39 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 39 "../src/archive-reader.vala"
			return;
#line 419 "archive-reader.c"
		} else {
#line 39 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 39 "../src/archive-reader.vala"
			return;
#line 427 "archive-reader.c"
		}
	}
}

static int
_archive_read_close_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_close ((struct archive*) self);
#line 43 "../src/archive-reader.vala"
	return result;
#line 439 "archive-reader.c"
}

void
boxes_archive_reader_reset (BoxesArchiveReader* self,
                            GError** error)
{
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 42 "../src/archive-reader.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/archive-reader.vala"
	_tmp0_ = self->archive;
#line 43 "../src/archive-reader.vala"
	_tmp1_ = self->archive;
#line 43 "../src/archive-reader.vala"
	boxes_execute_libarchive_function (_tmp0_, _archive_read_close_boxes_libarchive_function, _tmp1_, (guint) 1, &_inner_error0_);
#line 43 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 43 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 43 "../src/archive-reader.vala"
			return;
#line 465 "archive-reader.c"
		} else {
#line 43 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 43 "../src/archive-reader.vala"
			return;
#line 473 "archive-reader.c"
		}
	}
#line 44 "../src/archive-reader.vala"
	boxes_archive_reader_open_archive (self, &_inner_error0_);
#line 44 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 44 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 44 "../src/archive-reader.vala"
			return;
#line 486 "archive-reader.c"
		} else {
#line 44 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 44 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 44 "../src/archive-reader.vala"
			return;
#line 494 "archive-reader.c"
		}
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 61 "../src/archive-reader.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 61 "../src/archive-reader.vala"
	return _data14_;
#line 506 "archive-reader.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 61 "../src/archive-reader.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 516 "archive-reader.c"
		BoxesArchiveReader* self;
#line 61 "../src/archive-reader.vala"
		self = _data14_->self;
#line 61 "../src/archive-reader.vala"
		_fclose0 (_data14_->fd);
#line 61 "../src/archive-reader.vala"
		_g_object_unref0 (self);
#line 61 "../src/archive-reader.vala"
		g_slice_free (Block14Data, _data14_);
#line 526 "archive-reader.c"
	}
}

static int
_archive_read_data_skip_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_data_skip ((struct archive*) self);
#line 66 "../src/archive-reader.vala"
	return result;
#line 537 "archive-reader.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 73 "../src/archive-reader.vala"
	if ((*length) == (*size)) {
#line 73 "../src/archive-reader.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 73 "../src/archive-reader.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 552 "archive-reader.c"
	}
#line 73 "../src/archive-reader.vala"
	(*array)[(*length)++] = value;
#line 73 "../src/archive-reader.vala"
	(*array)[*length] = NULL;
#line 558 "archive-reader.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 74 "../src/archive-reader.vala"
	if ((*length) == (*size)) {
#line 74 "../src/archive-reader.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 74 "../src/archive-reader.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 573 "archive-reader.c"
	}
#line 74 "../src/archive-reader.vala"
	(*array)[(*length)++] = value;
#line 74 "../src/archive-reader.vala"
	(*array)[*length] = NULL;
#line 579 "archive-reader.c"
}

static int
___lambda23_ (Block14Data* _data14_)
{
	BoxesArchiveReader* self;
	struct archive* _tmp0_;
	FILE* _tmp1_;
	int result;
#line 85 "../src/archive-reader.vala"
	self = _data14_->self;
#line 85 "../src/archive-reader.vala"
	_tmp0_ = self->archive;
#line 85 "../src/archive-reader.vala"
	_tmp1_ = _data14_->fd;
#line 85 "../src/archive-reader.vala"
	result = archive_read_data_into_fd (_tmp0_, fileno (_tmp1_));
#line 85 "../src/archive-reader.vala"
	return result;
#line 599 "archive-reader.c"
}

static int
____lambda23__boxes_libarchive_function (gpointer self)
{
	int result;
	result = ___lambda23_ (self);
#line 85 "../src/archive-reader.vala"
	return result;
#line 609 "archive-reader.c"
}

static void
boxes_archive_reader_extract_files_recursive (BoxesArchiveReader* self,
                                              gchar** src_list,
                                              gint src_list_length1,
                                              gchar** dest_list,
                                              gint dest_list_length1,
                                              gboolean override_if_necessary,
                                              gboolean follow_hardlinks,
                                              GError** error)
{
	struct archive_entry* iterator = NULL;
	guint i = 0U;
	gchar** hardlink_src = NULL;
	gchar** _tmp0_;
	gint hardlink_src_length1;
	gint _hardlink_src_size_;
	gchar** hardlink_dest = NULL;
	gchar** _tmp1_;
	gint hardlink_dest_length1;
	gint _hardlink_dest_size_;
	gchar** _tmp38_;
	gint _tmp38__length1;
	GError* _inner_error0_ = NULL;
#line 47 "../src/archive-reader.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/archive-reader.vala"
	_vala_return_if_fail (src_list_length1 == dest_list_length1, "src_list.length == dest_list.length");
#line 53 "../src/archive-reader.vala"
	if (src_list_length1 == 0) {
#line 54 "../src/archive-reader.vala"
		return;
#line 643 "archive-reader.c"
	}
#line 57 "../src/archive-reader.vala"
	i = (guint) 0;
#line 58 "../src/archive-reader.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 58 "../src/archive-reader.vala"
	hardlink_src = _tmp0_;
#line 58 "../src/archive-reader.vala"
	hardlink_src_length1 = 0;
#line 58 "../src/archive-reader.vala"
	_hardlink_src_size_ = hardlink_src_length1;
#line 59 "../src/archive-reader.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 59 "../src/archive-reader.vala"
	hardlink_dest = _tmp1_;
#line 59 "../src/archive-reader.vala"
	hardlink_dest_length1 = 0;
#line 59 "../src/archive-reader.vala"
	_hardlink_dest_size_ = hardlink_dest_length1;
#line 61 "../src/archive-reader.vala"
	while (TRUE) {
#line 665 "archive-reader.c"
		Block14Data* _data14_;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		struct archive* _tmp4_;
		struct archive_entry* _tmp5_ = NULL;
		gboolean _tmp6_;
		gchar* dest = NULL;
		struct archive_entry* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gboolean _tmp13_ = FALSE;
		struct archive_entry* _tmp14_;
		const gchar* _tmp15_;
		gboolean _tmp27_ = FALSE;
		const gchar* _tmp31_;
		FILE* _tmp32_;
		struct archive* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		guint _tmp36_;
#line 61 "../src/archive-reader.vala"
		_data14_ = g_slice_new0 (Block14Data);
#line 61 "../src/archive-reader.vala"
		_data14_->_ref_count_ = 1;
#line 61 "../src/archive-reader.vala"
		_data14_->self = g_object_ref (self);
#line 61 "../src/archive-reader.vala"
		_tmp4_ = self->archive;
#line 61 "../src/archive-reader.vala"
		_tmp6_ = boxes_get_next_header (_tmp4_, &_tmp5_, (guint) 1, &_inner_error0_);
#line 61 "../src/archive-reader.vala"
		iterator = _tmp5_;
#line 61 "../src/archive-reader.vala"
		_tmp3_ = _tmp6_;
#line 61 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 61 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 61 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 61 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 61 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/archive-reader.vala"
				return;
#line 717 "archive-reader.c"
			} else {
#line 61 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 61 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 61 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 61 "../src/archive-reader.vala"
				return;
#line 733 "archive-reader.c"
			}
		}
#line 61 "../src/archive-reader.vala"
		if (_tmp3_) {
#line 61 "../src/archive-reader.vala"
			_tmp2_ = i < ((guint) src_list_length1);
#line 740 "archive-reader.c"
		} else {
#line 61 "../src/archive-reader.vala"
			_tmp2_ = FALSE;
#line 744 "archive-reader.c"
		}
#line 61 "../src/archive-reader.vala"
		if (!_tmp2_) {
#line 61 "../src/archive-reader.vala"
			block14_data_unref (_data14_);
#line 61 "../src/archive-reader.vala"
			_data14_ = NULL;
#line 61 "../src/archive-reader.vala"
			break;
#line 754 "archive-reader.c"
		}
#line 62 "../src/archive-reader.vala"
		_tmp7_ = iterator;
#line 62 "../src/archive-reader.vala"
		_tmp8_ = archive_entry_pathname (_tmp7_);
#line 62 "../src/archive-reader.vala"
		_tmp9_ = boxes_archive_reader_get_dest_file (self, src_list, (gint) src_list_length1, dest_list, (gint) dest_list_length1, _tmp8_);
#line 62 "../src/archive-reader.vala"
		dest = _tmp9_;
#line 64 "../src/archive-reader.vala"
		_tmp10_ = dest;
#line 64 "../src/archive-reader.vala"
		if (_tmp10_ == NULL) {
#line 768 "archive-reader.c"
			struct archive* _tmp11_;
			struct archive* _tmp12_;
#line 66 "../src/archive-reader.vala"
			_tmp11_ = self->archive;
#line 66 "../src/archive-reader.vala"
			_tmp12_ = self->archive;
#line 66 "../src/archive-reader.vala"
			boxes_execute_libarchive_function (_tmp11_, _archive_read_data_skip_boxes_libarchive_function, _tmp12_, (guint) 1, &_inner_error0_);
#line 66 "../src/archive-reader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/archive-reader.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 66 "../src/archive-reader.vala"
					g_propagate_error (error, _inner_error0_);
#line 66 "../src/archive-reader.vala"
					_g_free0 (dest);
#line 66 "../src/archive-reader.vala"
					block14_data_unref (_data14_);
#line 66 "../src/archive-reader.vala"
					_data14_ = NULL;
#line 66 "../src/archive-reader.vala"
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/archive-reader.vala"
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/archive-reader.vala"
					return;
#line 795 "archive-reader.c"
				} else {
#line 66 "../src/archive-reader.vala"
					_g_free0 (dest);
#line 66 "../src/archive-reader.vala"
					block14_data_unref (_data14_);
#line 66 "../src/archive-reader.vala"
					_data14_ = NULL;
#line 66 "../src/archive-reader.vala"
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/archive-reader.vala"
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 66 "../src/archive-reader.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/archive-reader.vala"
					g_clear_error (&_inner_error0_);
#line 66 "../src/archive-reader.vala"
					return;
#line 813 "archive-reader.c"
				}
			}
#line 68 "../src/archive-reader.vala"
			_g_free0 (dest);
#line 68 "../src/archive-reader.vala"
			block14_data_unref (_data14_);
#line 68 "../src/archive-reader.vala"
			_data14_ = NULL;
#line 68 "../src/archive-reader.vala"
			continue;
#line 824 "archive-reader.c"
		}
#line 71 "../src/archive-reader.vala"
		_tmp14_ = iterator;
#line 71 "../src/archive-reader.vala"
		_tmp15_ = archive_entry_hardlink (_tmp14_);
#line 71 "../src/archive-reader.vala"
		if (_tmp15_ != NULL) {
#line 832 "archive-reader.c"
			struct archive_entry* _tmp16_;
#line 71 "../src/archive-reader.vala"
			_tmp16_ = iterator;
#line 71 "../src/archive-reader.vala"
			_tmp13_ = archive_entry_size (_tmp16_) == ((la_int64_t) 0);
#line 838 "archive-reader.c"
		} else {
#line 71 "../src/archive-reader.vala"
			_tmp13_ = FALSE;
#line 842 "archive-reader.c"
		}
#line 71 "../src/archive-reader.vala"
		if (_tmp13_) {
#line 846 "archive-reader.c"
			struct archive_entry* _tmp17_;
			const gchar* _tmp18_;
			struct archive_entry* _tmp19_;
			const gchar* _tmp20_;
			struct archive_entry* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			guint _tmp26_;
#line 72 "../src/archive-reader.vala"
			_tmp17_ = iterator;
#line 72 "../src/archive-reader.vala"
			_tmp18_ = archive_entry_pathname (_tmp17_);
#line 72 "../src/archive-reader.vala"
			_tmp19_ = iterator;
#line 72 "../src/archive-reader.vala"
			_tmp20_ = archive_entry_hardlink (_tmp19_);
#line 72 "../src/archive-reader.vala"
			g_debug ("archive-reader.vala:72: Following hardlink of '%s' to '%s'.", _tmp18_, _tmp20_);
#line 73 "../src/archive-reader.vala"
			_tmp21_ = iterator;
#line 73 "../src/archive-reader.vala"
			_tmp22_ = archive_entry_hardlink (_tmp21_);
#line 73 "../src/archive-reader.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 73 "../src/archive-reader.vala"
			_vala_array_add1 (&hardlink_src, &hardlink_src_length1, &_hardlink_src_size_, _tmp23_);
#line 74 "../src/archive-reader.vala"
			_tmp24_ = dest;
#line 74 "../src/archive-reader.vala"
			_tmp25_ = g_strdup (_tmp24_);
#line 74 "../src/archive-reader.vala"
			_vala_array_add2 (&hardlink_dest, &hardlink_dest_length1, &_hardlink_dest_size_, _tmp25_);
#line 75 "../src/archive-reader.vala"
			_tmp26_ = i;
#line 75 "../src/archive-reader.vala"
			i = _tmp26_ + 1;
#line 77 "../src/archive-reader.vala"
			_g_free0 (dest);
#line 77 "../src/archive-reader.vala"
			block14_data_unref (_data14_);
#line 77 "../src/archive-reader.vala"
			_data14_ = NULL;
#line 77 "../src/archive-reader.vala"
			continue;
#line 893 "archive-reader.c"
		}
#line 80 "../src/archive-reader.vala"
		if (!override_if_necessary) {
#line 897 "archive-reader.c"
			const gchar* _tmp28_;
#line 80 "../src/archive-reader.vala"
			_tmp28_ = dest;
#line 80 "../src/archive-reader.vala"
			_tmp27_ = g_file_test (_tmp28_, G_FILE_TEST_EXISTS);
#line 903 "archive-reader.c"
		} else {
#line 80 "../src/archive-reader.vala"
			_tmp27_ = FALSE;
#line 907 "archive-reader.c"
		}
#line 80 "../src/archive-reader.vala"
		if (_tmp27_) {
#line 911 "archive-reader.c"
			const gchar* _tmp29_;
			GError* _tmp30_;
#line 81 "../src/archive-reader.vala"
			_tmp29_ = dest;
#line 81 "../src/archive-reader.vala"
			_tmp30_ = g_error_new (G_IO_ERROR, G_IO_ERROR_EXISTS, "Destination file '%s' already exists.", _tmp29_);
#line 81 "../src/archive-reader.vala"
			_inner_error0_ = _tmp30_;
#line 81 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 81 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 81 "../src/archive-reader.vala"
				_g_free0 (dest);
#line 81 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 81 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 81 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/archive-reader.vala"
				return;
#line 936 "archive-reader.c"
			} else {
#line 81 "../src/archive-reader.vala"
				_g_free0 (dest);
#line 81 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 81 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 81 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 81 "../src/archive-reader.vala"
				return;
#line 954 "archive-reader.c"
			}
		}
#line 84 "../src/archive-reader.vala"
		_tmp31_ = dest;
#line 84 "../src/archive-reader.vala"
		_tmp32_ = g_fopen (_tmp31_, "w+");
#line 84 "../src/archive-reader.vala"
		_data14_->fd = _tmp32_;
#line 85 "../src/archive-reader.vala"
		_tmp33_ = self->archive;
#line 85 "../src/archive-reader.vala"
		boxes_execute_libarchive_function (_tmp33_, ____lambda23__boxes_libarchive_function, _data14_, (guint) 1, &_inner_error0_);
#line 85 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 85 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 85 "../src/archive-reader.vala"
				_g_free0 (dest);
#line 85 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 85 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 85 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/archive-reader.vala"
				return;
#line 985 "archive-reader.c"
			} else {
#line 85 "../src/archive-reader.vala"
				_g_free0 (dest);
#line 85 "../src/archive-reader.vala"
				block14_data_unref (_data14_);
#line 85 "../src/archive-reader.vala"
				_data14_ = NULL;
#line 85 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 85 "../src/archive-reader.vala"
				return;
#line 1003 "archive-reader.c"
			}
		}
#line 87 "../src/archive-reader.vala"
		_tmp34_ = dest;
#line 87 "../src/archive-reader.vala"
		_tmp35_ = self->priv->filename;
#line 87 "../src/archive-reader.vala"
		g_debug ("archive-reader.vala:87: Extracted file '%s' from archive '%s'.", _tmp34_, _tmp35_);
#line 88 "../src/archive-reader.vala"
		_tmp36_ = i;
#line 88 "../src/archive-reader.vala"
		i = _tmp36_ + 1;
#line 61 "../src/archive-reader.vala"
		_g_free0 (dest);
#line 61 "../src/archive-reader.vala"
		block14_data_unref (_data14_);
#line 61 "../src/archive-reader.vala"
		_data14_ = NULL;
#line 1022 "archive-reader.c"
	}
#line 91 "../src/archive-reader.vala"
	if (((guint) src_list_length1) != i) {
#line 1026 "archive-reader.c"
		GError* _tmp37_;
#line 92 "../src/archive-reader.vala"
		_tmp37_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_FOUND, "At least one specified file was not found in the archive.");
#line 92 "../src/archive-reader.vala"
		_inner_error0_ = _tmp37_;
#line 92 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 92 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 92 "../src/archive-reader.vala"
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/archive-reader.vala"
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/archive-reader.vala"
			return;
#line 1042 "archive-reader.c"
		} else {
#line 92 "../src/archive-reader.vala"
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/archive-reader.vala"
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 92 "../src/archive-reader.vala"
			return;
#line 1054 "archive-reader.c"
		}
	}
#line 94 "../src/archive-reader.vala"
	boxes_archive_reader_reset (self, &_inner_error0_);
#line 94 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 94 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 94 "../src/archive-reader.vala"
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/archive-reader.vala"
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/archive-reader.vala"
			return;
#line 1071 "archive-reader.c"
		} else {
#line 94 "../src/archive-reader.vala"
			hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/archive-reader.vala"
			hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 94 "../src/archive-reader.vala"
			return;
#line 1083 "archive-reader.c"
		}
	}
#line 96 "../src/archive-reader.vala"
	_tmp38_ = hardlink_src;
#line 96 "../src/archive-reader.vala"
	_tmp38__length1 = hardlink_src_length1;
#line 96 "../src/archive-reader.vala"
	if (_tmp38__length1 > 0) {
#line 97 "../src/archive-reader.vala"
		if (follow_hardlinks) {
#line 1094 "archive-reader.c"
			gchar** _tmp39_;
			gint _tmp39__length1;
			gchar** _tmp40_;
			gint _tmp40__length1;
#line 98 "../src/archive-reader.vala"
			_tmp39_ = hardlink_src;
#line 98 "../src/archive-reader.vala"
			_tmp39__length1 = hardlink_src_length1;
#line 98 "../src/archive-reader.vala"
			_tmp40_ = hardlink_dest;
#line 98 "../src/archive-reader.vala"
			_tmp40__length1 = hardlink_dest_length1;
#line 98 "../src/archive-reader.vala"
			boxes_archive_reader_extract_files_recursive (self, _tmp39_, (gint) _tmp39__length1, _tmp40_, (gint) _tmp40__length1, override_if_necessary, FALSE, &_inner_error0_);
#line 98 "../src/archive-reader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/archive-reader.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 98 "../src/archive-reader.vala"
					g_propagate_error (error, _inner_error0_);
#line 98 "../src/archive-reader.vala"
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/archive-reader.vala"
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/archive-reader.vala"
					return;
#line 1121 "archive-reader.c"
				} else {
#line 98 "../src/archive-reader.vala"
					hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/archive-reader.vala"
					hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/archive-reader.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/archive-reader.vala"
					g_clear_error (&_inner_error0_);
#line 98 "../src/archive-reader.vala"
					return;
#line 1133 "archive-reader.c"
				}
			}
		} else {
			gchar* msg = NULL;
			gchar* _tmp41_;
			const gchar* _tmp42_;
			GError* _tmp43_;
#line 100 "../src/archive-reader.vala"
			_tmp41_ = g_strdup ("Maximum recursion depth exceeded. It is likely that a hardlink points " \
"to itself.");
#line 100 "../src/archive-reader.vala"
			msg = _tmp41_;
#line 102 "../src/archive-reader.vala"
			_tmp42_ = msg;
#line 102 "../src/archive-reader.vala"
			_tmp43_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_WOULD_RECURSE, _tmp42_);
#line 102 "../src/archive-reader.vala"
			_inner_error0_ = _tmp43_;
#line 102 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 102 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 102 "../src/archive-reader.vala"
				_g_free0 (msg);
#line 102 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/archive-reader.vala"
				return;
#line 1163 "archive-reader.c"
			} else {
#line 102 "../src/archive-reader.vala"
				_g_free0 (msg);
#line 102 "../src/archive-reader.vala"
				hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/archive-reader.vala"
				hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 102 "../src/archive-reader.vala"
				return;
#line 1177 "archive-reader.c"
			}
#line 97 "../src/archive-reader.vala"
			_g_free0 (msg);
#line 1181 "archive-reader.c"
		}
	}
#line 47 "../src/archive-reader.vala"
	hardlink_dest = (_vala_array_free (hardlink_dest, hardlink_dest_length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/archive-reader.vala"
	hardlink_src = (_vala_array_free (hardlink_src, hardlink_src_length1, (GDestroyNotify) g_free), NULL);
#line 1188 "archive-reader.c"
}

static gchar*
boxes_archive_reader_get_dest_file (BoxesArchiveReader* self,
                                    gchar** src_list,
                                    gint src_list_length1,
                                    gchar** dest_list,
                                    gint dest_list_length1,
                                    const gchar* src)
{
	gchar* result;
#line 107 "../src/archive-reader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../src/archive-reader.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 1204 "archive-reader.c"
	{
		guint j = 0U;
#line 108 "../src/archive-reader.vala"
		j = (guint) 0;
#line 1209 "archive-reader.c"
		{
			gboolean _tmp0_ = FALSE;
#line 108 "../src/archive-reader.vala"
			_tmp0_ = TRUE;
#line 108 "../src/archive-reader.vala"
			while (TRUE) {
#line 1216 "archive-reader.c"
				const gchar* _tmp2_;
#line 108 "../src/archive-reader.vala"
				if (!_tmp0_) {
#line 1220 "archive-reader.c"
					guint _tmp1_;
#line 108 "../src/archive-reader.vala"
					_tmp1_ = j;
#line 108 "../src/archive-reader.vala"
					j = _tmp1_ + 1;
#line 1226 "archive-reader.c"
				}
#line 108 "../src/archive-reader.vala"
				_tmp0_ = FALSE;
#line 108 "../src/archive-reader.vala"
				if (!(j < ((guint) src_list_length1))) {
#line 108 "../src/archive-reader.vala"
					break;
#line 1234 "archive-reader.c"
				}
#line 109 "../src/archive-reader.vala"
				_tmp2_ = src_list[j];
#line 109 "../src/archive-reader.vala"
				if (g_strcmp0 (_tmp2_, src) == 0) {
#line 1240 "archive-reader.c"
					const gchar* _tmp3_;
					gchar* _tmp4_;
#line 110 "../src/archive-reader.vala"
					_tmp3_ = dest_list[j];
#line 110 "../src/archive-reader.vala"
					_tmp4_ = g_strdup (_tmp3_);
#line 110 "../src/archive-reader.vala"
					result = _tmp4_;
#line 110 "../src/archive-reader.vala"
					return result;
#line 1251 "archive-reader.c"
				}
			}
		}
	}
#line 113 "../src/archive-reader.vala"
	result = NULL;
#line 113 "../src/archive-reader.vala"
	return result;
#line 1260 "archive-reader.c"
}

static int
_archive_read_support_format_all_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_support_format_all ((struct archive*) self);
#line 120 "../src/archive-reader.vala"
	return result;
#line 1270 "archive-reader.c"
}

static int
___lambda20_ (BoxesArchiveReader* self)
{
	struct archive* _tmp0_;
	int* _tmp1_;
	int result;
#line 122 "../src/archive-reader.vala"
	_tmp0_ = self->archive;
#line 122 "../src/archive-reader.vala"
	_tmp1_ = self->priv->format;
#line 122 "../src/archive-reader.vala"
	result = archive_read_set_format (_tmp0_, *_tmp1_);
#line 122 "../src/archive-reader.vala"
	return result;
#line 1287 "archive-reader.c"
}

static int
____lambda20__boxes_libarchive_function (gpointer self)
{
	int result;
	result = ___lambda20_ ((BoxesArchiveReader*) self);
#line 122 "../src/archive-reader.vala"
	return result;
#line 1297 "archive-reader.c"
}

static int
_archive_read_support_filter_all_boxes_libarchive_function (gpointer self)
{
	int result;
	result = archive_read_support_filter_all ((struct archive*) self);
#line 125 "../src/archive-reader.vala"
	return result;
#line 1307 "archive-reader.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 127 "../src/archive-reader.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 127 "../src/archive-reader.vala"
	return _data15_;
#line 1317 "archive-reader.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 127 "../src/archive-reader.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 1327 "archive-reader.c"
		BoxesArchiveReader* self;
#line 127 "../src/archive-reader.vala"
		self = _data15_->self;
#line 127 "../src/archive-reader.vala"
		_g_object_unref0 (self);
#line 127 "../src/archive-reader.vala"
		g_slice_free (Block15Data, _data15_);
#line 1335 "archive-reader.c"
	}
}

static int
_____lambda21_ (Block15Data* _data15_)
{
	BoxesArchiveReader* self;
	struct archive* _tmp0_;
	int result;
#line 128 "../src/archive-reader.vala"
	self = _data15_->self;
#line 128 "../src/archive-reader.vala"
	_tmp0_ = self->archive;
#line 128 "../src/archive-reader.vala"
	result = archive_read_append_filter (_tmp0_, _data15_->filter);
#line 128 "../src/archive-reader.vala"
	return result;
#line 1353 "archive-reader.c"
}

static int
______lambda21__boxes_libarchive_function (gpointer self)
{
	int result;
	result = _____lambda21_ (self);
#line 128 "../src/archive-reader.vala"
	return result;
#line 1363 "archive-reader.c"
}

static int
__lambda22_ (BoxesArchiveReader* self)
{
	struct archive* _tmp0_;
	const gchar* _tmp1_;
	int result;
#line 131 "../src/archive-reader.vala"
	_tmp0_ = self->archive;
#line 131 "../src/archive-reader.vala"
	_tmp1_ = self->priv->filename;
#line 131 "../src/archive-reader.vala"
	result = archive_read_open_filename (_tmp0_, _tmp1_, (gsize) BOXES_ARCHIVE_READER_BLOCK_SIZE);
#line 131 "../src/archive-reader.vala"
	return result;
#line 1380 "archive-reader.c"
}

static int
___lambda22__boxes_libarchive_function (gpointer self)
{
	int result;
	result = __lambda22_ ((BoxesArchiveReader*) self);
#line 131 "../src/archive-reader.vala"
	return result;
#line 1390 "archive-reader.c"
}

static void
boxes_archive_reader_open_archive (BoxesArchiveReader* self,
                                   GError** error)
{
	struct archive* _tmp0_;
	int* _tmp1_;
	GList* _tmp5_;
	struct archive* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 116 "../src/archive-reader.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/archive-reader.vala"
	_tmp0_ = archive_read_new ();
#line 117 "../src/archive-reader.vala"
	_archive_read_free0 (self->archive);
#line 117 "../src/archive-reader.vala"
	self->archive = _tmp0_;
#line 119 "../src/archive-reader.vala"
	_tmp1_ = self->priv->format;
#line 119 "../src/archive-reader.vala"
	if (_tmp1_ == NULL) {
#line 1414 "archive-reader.c"
		struct archive* _tmp2_;
		struct archive* _tmp3_;
#line 120 "../src/archive-reader.vala"
		_tmp2_ = self->archive;
#line 120 "../src/archive-reader.vala"
		_tmp3_ = self->archive;
#line 120 "../src/archive-reader.vala"
		boxes_execute_libarchive_function (_tmp2_, _archive_read_support_format_all_boxes_libarchive_function, _tmp3_, (guint) 1, &_inner_error0_);
#line 120 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 120 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 120 "../src/archive-reader.vala"
				return;
#line 1431 "archive-reader.c"
			} else {
#line 120 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 120 "../src/archive-reader.vala"
				return;
#line 1439 "archive-reader.c"
			}
		}
	} else {
		struct archive* _tmp4_;
#line 122 "../src/archive-reader.vala"
		_tmp4_ = self->archive;
#line 122 "../src/archive-reader.vala"
		boxes_execute_libarchive_function (_tmp4_, ____lambda20__boxes_libarchive_function, self, (guint) 1, &_inner_error0_);
#line 122 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 122 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 122 "../src/archive-reader.vala"
				return;
#line 1456 "archive-reader.c"
			} else {
#line 122 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 122 "../src/archive-reader.vala"
				return;
#line 1464 "archive-reader.c"
			}
		}
	}
#line 124 "../src/archive-reader.vala"
	_tmp5_ = self->priv->filters;
#line 124 "../src/archive-reader.vala"
	if (_tmp5_ == NULL) {
#line 1472 "archive-reader.c"
		struct archive* _tmp6_;
		struct archive* _tmp7_;
#line 125 "../src/archive-reader.vala"
		_tmp6_ = self->archive;
#line 125 "../src/archive-reader.vala"
		_tmp7_ = self->archive;
#line 125 "../src/archive-reader.vala"
		boxes_execute_libarchive_function (_tmp6_, _archive_read_support_filter_all_boxes_libarchive_function, _tmp7_, (guint) 1, &_inner_error0_);
#line 125 "../src/archive-reader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/archive-reader.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 125 "../src/archive-reader.vala"
				g_propagate_error (error, _inner_error0_);
#line 125 "../src/archive-reader.vala"
				return;
#line 1489 "archive-reader.c"
			} else {
#line 125 "../src/archive-reader.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/archive-reader.vala"
				g_clear_error (&_inner_error0_);
#line 125 "../src/archive-reader.vala"
				return;
#line 1497 "archive-reader.c"
			}
		}
	} else {
		GList* _tmp8_;
#line 127 "../src/archive-reader.vala"
		_tmp8_ = self->priv->filters;
#line 1504 "archive-reader.c"
		{
			GList* filter_collection = NULL;
			GList* filter_it = NULL;
#line 127 "../src/archive-reader.vala"
			filter_collection = _tmp8_;
#line 127 "../src/archive-reader.vala"
			for (filter_it = filter_collection; filter_it != NULL; filter_it = filter_it->next) {
#line 1512 "archive-reader.c"
				int filter = 0;
#line 127 "../src/archive-reader.vala"
				filter = (int) ((gintptr) filter_it->data);
#line 1516 "archive-reader.c"
				{
					Block15Data* _data15_;
					struct archive* _tmp9_;
#line 127 "../src/archive-reader.vala"
					_data15_ = g_slice_new0 (Block15Data);
#line 127 "../src/archive-reader.vala"
					_data15_->_ref_count_ = 1;
#line 127 "../src/archive-reader.vala"
					_data15_->self = g_object_ref (self);
#line 127 "../src/archive-reader.vala"
					_data15_->filter = filter;
#line 128 "../src/archive-reader.vala"
					_tmp9_ = self->archive;
#line 128 "../src/archive-reader.vala"
					boxes_execute_libarchive_function (_tmp9_, ______lambda21__boxes_libarchive_function, _data15_, (guint) 1, &_inner_error0_);
#line 128 "../src/archive-reader.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../src/archive-reader.vala"
						if (_inner_error0_->domain == G_IO_ERROR) {
#line 128 "../src/archive-reader.vala"
							g_propagate_error (error, _inner_error0_);
#line 128 "../src/archive-reader.vala"
							block15_data_unref (_data15_);
#line 128 "../src/archive-reader.vala"
							_data15_ = NULL;
#line 128 "../src/archive-reader.vala"
							return;
#line 1544 "archive-reader.c"
						} else {
#line 128 "../src/archive-reader.vala"
							block15_data_unref (_data15_);
#line 128 "../src/archive-reader.vala"
							_data15_ = NULL;
#line 128 "../src/archive-reader.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../src/archive-reader.vala"
							g_clear_error (&_inner_error0_);
#line 128 "../src/archive-reader.vala"
							return;
#line 1556 "archive-reader.c"
						}
					}
#line 127 "../src/archive-reader.vala"
					block15_data_unref (_data15_);
#line 127 "../src/archive-reader.vala"
					_data15_ = NULL;
#line 1563 "archive-reader.c"
				}
			}
		}
	}
#line 131 "../src/archive-reader.vala"
	_tmp10_ = self->archive;
#line 131 "../src/archive-reader.vala"
	boxes_execute_libarchive_function (_tmp10_, ___lambda22__boxes_libarchive_function, self, (guint) 1, &_inner_error0_);
#line 131 "../src/archive-reader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/archive-reader.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 131 "../src/archive-reader.vala"
			g_propagate_error (error, _inner_error0_);
#line 131 "../src/archive-reader.vala"
			return;
#line 1580 "archive-reader.c"
		} else {
#line 131 "../src/archive-reader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/archive-reader.vala"
			g_clear_error (&_inner_error0_);
#line 131 "../src/archive-reader.vala"
			return;
#line 1588 "archive-reader.c"
		}
	}
}

static void
boxes_archive_reader_class_init (BoxesArchiveReaderClass * klass,
                                 gpointer klass_data)
{
#line 3 "../src/archive-reader.vala"
	boxes_archive_reader_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/archive-reader.vala"
	g_type_class_adjust_private_offset (klass, &BoxesArchiveReader_private_offset);
#line 3 "../src/archive-reader.vala"
	G_OBJECT_CLASS (klass)->finalize = boxes_archive_reader_finalize;
#line 1603 "archive-reader.c"
}

static void
boxes_archive_reader_instance_init (BoxesArchiveReader * self,
                                    gpointer klass)
{
#line 3 "../src/archive-reader.vala"
	self->priv = boxes_archive_reader_get_instance_private (self);
#line 1612 "archive-reader.c"
}

static void
boxes_archive_reader_finalize (GObject * obj)
{
	BoxesArchiveReader * self;
#line 3 "../src/archive-reader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_ARCHIVE_READER, BoxesArchiveReader);
#line 7 "../src/archive-reader.vala"
	_archive_read_free0 (self->archive);
#line 9 "../src/archive-reader.vala"
	_g_free0 (self->priv->filename);
#line 10 "../src/archive-reader.vala"
	_g_free0 (self->priv->format);
#line 11 "../src/archive-reader.vala"
	(self->priv->filters == NULL) ? NULL : (self->priv->filters = (g_list_free (self->priv->filters), NULL));
#line 3 "../src/archive-reader.vala"
	G_OBJECT_CLASS (boxes_archive_reader_parent_class)->finalize (obj);
#line 1631 "archive-reader.c"
}

static GType
boxes_archive_reader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoxesArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesArchiveReader), 0, (GInstanceInitFunc) boxes_archive_reader_instance_init, NULL };
	GType boxes_archive_reader_type_id;
	boxes_archive_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "BoxesArchiveReader", &g_define_type_info, 0);
	BoxesArchiveReader_private_offset = g_type_add_instance_private (boxes_archive_reader_type_id, sizeof (BoxesArchiveReaderPrivate));
	return boxes_archive_reader_type_id;
}

GType
boxes_archive_reader_get_type (void)
{
	static volatile gsize boxes_archive_reader_type_id__once = 0;
	if (g_once_init_enter (&boxes_archive_reader_type_id__once)) {
		GType boxes_archive_reader_type_id;
		boxes_archive_reader_type_id = boxes_archive_reader_get_type_once ();
		g_once_init_leave (&boxes_archive_reader_type_id__once, boxes_archive_reader_type_id);
	}
	return boxes_archive_reader_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

